Ruby master - Bug #13636

REXML::Document.parse_stream doesn't handle when closing tag not provided
06/06/2017 09:35 PM - fanantoxa (Anton Sivakov)

Status: Closed

Priority: Normal

Assignee: kou (Kouhei Sutou)

Target version: 25

ruby -v: ruby 2.4.0p0 (2016-12-24 revision Backport: 2.2: WONTFIX, 2.3: DONE, 2.4: DONE
57164) [x86_64-linux]

Description
I've tried to use REXML for parsing but got unexpected behavior:

Here is example:

require 'rexml/document'
require 'rexml/streamlistener'

class Handler include REXML::StreamListener end
xmll = StringIO.new ("<body><item>test</item></body>")

xml2 StringIO.new ("<body><item>test</body>")
xml3 = StringIO.new ("<body><item>test</item>")

handler = Handler.new

REXML: :Document .parse_stream(xmll, handler) # => nil

REXML: :Document .parse_stream(xml2, handler)

# => REXML: :ParseException: Missing end tag for 'item' (got "body")
REXML: :Document .parse_stream(xml3, handler) # => nil

Actualy XML: "test" is broken so it's expected to get:

REXML: :ParseException.new( "Missing end tag for body")

| can't rely on REXML parse since I'm not getting exception when XML data structure not valid.

Associated revisions

Revision d311921d - 06/07/2017 01:01 PM - kou (Kouhei Sutou)

rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]

Reported by Anton Sivakov. Thanks!!!

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59033 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 59033 - 06/07/2017 01:01 PM - kou (Kouhei Sutou)
rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]

Reported by Anton Sivakov. Thanks!!!

Revision 59033 - 06/07/2017 01:01 PM - kou (Kouhei Sutou)
rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]

Reported by Anton Sivakov. Thanks!!!
Revision 59033 - 06/07/2017 01:01 PM - kou (Kouhei Sutou)

rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]
Reported by Anton Sivakov. Thanks!!!
Revision 59034 - 06/07/2017 01:01 PM - svn
e properties.
Revision 971b99f3 - 06/30/2017 12:58 PM - usa (Usaku NAKAMURA)
merge revision(s) 59033,59034: [Backport #13636]
rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]
Reported by Anton Sivakov. Thanks!!!
* properties.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@59239 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 59239 - 06/30/2017 12:58 PM - usa (Usaku NAKAMURA)
merge revision(s) 59033,59034: [Backport #13636]
rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]
Reported by Anton Sivakov. Thanks!!!
* properties.
Revision 3fd2cbec - 07/23/2017 07:33 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 59033,59034: [Backport #13636]
rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]
Reported by Anton Sivakov. Thanks!!!
* properties.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@59399 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 59399 - 07/23/2017 07:33 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 59033,59034: [Backport #13636]
rexml: add close tag check on end of document to StreamParser
[ruby-core:81593] [Bug #13636]
Reported by Anton Sivakov. Thanks!!!

* properties.

History

#1 - 06/06/2017 10:08 PM - fanantoxa (Anton Sivakov)

Expected to get exception for xmI3 example

#2 - 06/06/2017 10:35 PM - hsbt (Hiroshi SHIBATA)
- Target version set to 2.5

- Assignee set to kou (Kouhei Sutou)
- Status changed from Open to Assigned

#3 - 06/07/2017 01:01 PM - kou (Kouhei Sutou)

- Status changed from Assigned to Closed

Applied in changeset trunk|r59033.

rexml: add close tag check on end of document to StreamParser

[ruby-core:81593] [Bug #13636]

Reported by Anton Sivakov. Thanks!!!
#4 - 06/07/2017 01:02 PM - kou (Kouhei Sutou)
Thanks for your report.

I've added a validation on end of document.

#5 - 06/29/2017 05:03 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: WONTFIX, 2.3: REQUIRED, 2.4: REQUIRED

#6 - 06/30/2017 12:58 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: WONTFIX, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: WONTFIX, 2.3: DONE, 2.4: REQUIRED

ruby_2 3 r59239 merged revision(s) 59033,59034.

#7 - 07/23/2017 07:33 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: WONTFIX, 2.3: DONE, 2.4: REQUIRED to 2.2: WONTFIX, 2.3: DONE, 2.4: DONE

ruby_2 4 r59399 merged revision(s) 59033,59034.
https://bugs.ruby-lang.org/projects/ruby-trunk/repository/trunk/revisions/59033
https://bugs.ruby-lang.org/issues/13636
http://www.tcpdf.org

